<?php
require_once "MySQL.class.php";

class Launchpad {
    var $sourceCode;

    public function loadPage($page) {
        $sourceFile = fopen($this->createURL($page), "rt");

        if ($sourceFile) {
            while (!feof($sourceFile)) {
                $line = htmlentities(fgets($sourceFile));

                if (strlen($line) > 1) {
                    $this->sourceCode = array_merge($this->sourceCode, array($line));
                }
            }

            fClose($sourceFile);

            $this->separateTemplates();

            return true;
        } else {
            print "Erro ao carregar as informaes do Launchpad! Tente novamente mais tarde.";
        }

        return false;
    }

    public function separateTemplates() {
        $j = 0;

        $mysql = new MySQL();

        for ($i = 0; $i < sizeof($this->sourceCode); $i++) {
            if ($i = 0 and eregi("class=&quot;batch-navigation-index&quot;>", $this->sourceCode[$i])) {
                print $this->sourceCode[$i + 2];
            }

            if (eregi("\+translate&quot", $this->sourceCode[$i])) {
                ereg("&gt;(.*)&lt;+", $this->sourceCode[$i], $program);
                ereg("href=&quot;(.*)&quot;+", $this->sourceCode[$i], $url);
                ereg("&lt;td&gt;(.*)&lt;/td&gt;+", $this->sourceCode[$i + 2], $length);
                
                for ($k = $i + 10; $k <= $i + 30; $k++) {
                    if (ereg("untranslated&quot;&gt;(.*)&lt;", $this->sourceCode[$k])) {
                        $untranslated = true;
                        ereg("untranslated&quot;&gt;(.*)&lt;", $this->sourceCode[$k], $untranslatedNumber);

                        break;
                    }
                }

                if ($untranslated) {
                    $template[$j] = $program[1];
                    $url[$j] = "https://translations.launchpad.net" . $url[1];
                    $lengths[$j] = $length[1];
                    $untranslate[$j] = $untranslatedNumber[1];

                    $sql = "CALL up_SalvarPacote('" . $template[$j] . "', '" . $url[$j] . "', '" . $lengths[$j] . "', '" . $untranslate[$j] . "');";
                    $query = mysql_query($sql);

                    $untranslated = false;
                }

                $j++;
            }
        }
    }

    public function createURL($page) {
        $page = ($page == 1 || $page == 0) ? 1 : ($page - 1) * 300;
        $pageURL = "https://translations.launchpad.net/ubuntu/karmic/+lang/pt_BR/+index?start=" . $page . "&batch=300";

        return $pageURL;
    }
}
?>
